// kurs.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <iostream>
#include <tchar.h>

#include "logic.h"
#include "lab1.h"
#include "lab2.h"

void ShowMenu()
{
  std::cout<<"1. calculate"<<std::endl;
  std::cout<<"2. gold method"<<std::endl;
  std::cout<<"3. divide method"<<std::endl;
  std::cout<<"4. compare methods"<<std::endl;
  std::cout<<"5. exit"<<std::endl;
}

int _tmain(int argc, _TCHAR* argv[])
{
  double Ey=0.0000001;
  double R=0.500000;

  while(1)
  {
    ShowMenu();

    char c;
    std::cin>>c;
    switch(c)
    {
    case '1':
      lab1();
      break;
    case '2':
      {
        std::cout<<"----------------------------------------------------------------------------"<<std::endl;
        std::cout<<"Method:  gold"<<std::endl;
        double Rstart=0.5,Rend=1,Rstep=0.1;
        int Rindex=0;
        int Rcount=(int) ((Rend-Rstart)/Rstep);
        for(double R=Rstart;R<=Rend;R+=Rstep,Rindex++)
        {
          lab2_show(Ey,R,gold_method,lab2_math);
        }
        std::cout<<"----------------------------------------------------------------------------"<<std::endl;
      }
      break;
    case '3':
      {
        std::cout<<"----------------------------------------------------------------------------"<<std::endl;
        std::cout<<"Method:  divide"<<std::endl;
        double Rstart=0.5,Rend=1,Rstep=0.1;
        int Rindex=0;
        int Rcount=(int) ((Rend-Rstart)/Rstep);
        for(double R=Rstart;R<=Rend;R+=Rstep,Rindex++)
        {
          lab2_show(Ey,R,divide_method,lab2_math);
        }
        std::cout<<"----------------------------------------------------------------------------"<<std::endl;
      }
      break;
    case '4':
      {
        std::cout<<"----------------------------------------------------------------------------"<<std::endl;
        std::cout<<"Compare method"<<std::endl;

        int itgold=0;
        int itdiv=0;

        double Rstart=0.5,Rend=1,Rstep=0.1;
        int Rindex=0;
        int Rcount=(int) ((Rend-Rstart)/Rstep);
        for(double R=Rstart;R<=Rend;R+=Rstep,Rindex++)
        {
          std::cout<<"Gold method   : ";
          MethodResult &mrgold=lab2_show(Ey,R,gold_method,lab2_math);
          itgold+=mrgold.count;
          std::cout<<"Divide method : ";
          MethodResult &mrdiv=lab2_show(Ey,R,divide_method,lab2_math);
          itdiv+=mrdiv.count;
        }

        std::cout<<std::endl;
        std::cout<<"                     || Divide method |    Gold Method"<<std::endl;
        std::cout<<"------------------------------------------------------"<<std::endl;
        std::cout<<"Number of iterations ||";
        std::cout.width(15);
        std::cout<<itdiv<<"|";
        std::cout.width(15);
        std::cout<<itgold<<std::endl<<std::endl;
      }
      break;
    default:
      return 0;
    }
  }
	return 0;
}
